//NOT SET YET = SEARCH FOR THIS

//INCLUDE THESE LIBRARIES//
#include <Wire.h> //----------------------NEEDED BY AdaRGBMod.h & Adafruit_MCP23017.h
#include <AdaRGBMod.h> //-----------------NEEDED FOR I2C DISPLAY
#include <utility/Adafruit_MCP23017.h> //-NEEDED FOR I2C DISPLAY
#include <EEPROMex.h> //------------------FOR READ & WRITE OF EEPROM
#include "Arduino.h" //-------------------ALWAYS INCLUDE FOR AVOIDING ISSUES
#include <OneWire.h> //-------------------NEEDED BY DALLASTEMPERATURE
#include <DallasTemperature.h> //---------NEEDED FOR THEMAL SENSORS
#include <SimpleDHT.h> //-----------------NEEDED FOR DHT22 HUMIDITY-TEMP SENSOR
//INCLUDE THESE LIBRARIES//

//PHYSICAL PINS
const int PinEnable = 7; //--------------------------------ONE ENABLE FOR ALL 4 MOTORS
const int PinStep1 = 16; const int PinDir1 = 20; //--------SET MOTOR DRIVER PINS
const int PinStep2 = 21; const int PinDir2 = 22; //--------SET MOTOR DRIVER PINS

const int PinStep4 = 5; const int PinDir4 = 4; //----------SET MOTOR DRIVER PINS
const int PinStep3 = 3; const int PinDir3 = 0 ;//----------SET MOTOR DRIVER PINS

const int PinLim1 = 8; const int PinLim2 = 6; //-----------SET LIMIT PINS
const int PinLim3 = 2; const int PinLim4 = 12; //----------SET LIMIT PINS
const int PinStepInput = 11; const int PinDirInput = 9; //-THESE ARE LIMIT PINS, DRIVEN BY RUIDA
#define PinFlow 17 //--------------------------------------PIN CONNECTED TO FLOW METER
const int PinDHT22 = 23; //--------------------------------DHT22 SIGNAL (WITH PULLUP)
const int PinDallasBus = 1; //-----------------------------PIN THE DALLAS TEMPERATURE SENSORS CONNECT TO (WITH 4.7K PULLUP)
const int PinChill = 14; //--------------------------------HEATER OUTPUT DRIVING A 120V SSR (HIGH=ON)
const int PinMisc = 10; //---------------------------------HEATER OUTPUT DRIVING A 120V SSR (HIGH=ON)
const int PinLaser = 15; //--------------------------------USING A THERMISTOR PIN BECAUSE IT'S AVAILABLE!
const int PinLED = 13; //----------------------------------THE LED PIN, PROBABLY UNUSED.
//PHYSICAL PINS

//MCP23017 PHYSICAL PINS
#define MCP_ROW1_PIN 5 //-BUTTON ROWS & COLUMNS
#define MCP_ROW2_PIN 4 //-BUTTON ROWS & COLUMNS
#define MCP_ROW3_PIN 1 //-BUTTON ROWS & COLUMNS
#define MCP_ROW4_PIN 0 //-BUTTON ROWS & COLUMNS
#define MCP_COL1_PIN 6 //-BUTTON ROWS & COLUMNS
#define MCP_COL2_PIN 3 //-BUTTON ROWS & COLUMNS
#define MCP_COL3_PIN 2 //-BUTTON ROWS & COLUMNS
//THE REST ARE DEFINED BY THE LIBRARY
//MCP23017 PHYSICAL PINS

//DALLAS SENSOR ORDER
const int FromChillerSensor = 4; //-ADDRESSES USUALLY ARE NOT
const int AmbientSensor = 0; //-----MARKED SO IT CAN
const int FromLaserSensor = 2; //---TAKE SOME TRIAL
const int ColdTankSensor = 3; //----AND ERROR
const int WarmTankSensor = 1; //----TO GET THESE RIGHT
//DALLAS SENSOR ORDER

//USER SETTINGS
const float Home_Value = 63.195;  //----------------------------------------DISTANCE FROM LENS TO BED AFTER HOMING IS DONE (MM)
const float STEP_PER_MM = 53.5714286;  //-----------------------------------USED FOR CALCULATING DISPLAYED POSITIONS
const int MaxZval = 360; //-------------------------------------------------MAXIMUM TRAVEL OF Z AXIS
const int MOT_OFFSET1 = 755;  //--------------------------------------------HOW MUCH MOTOR 1 SHOULD BE BELOW LIMIT LEVEL WHEN AT TRUE LEVEL.
const int MOT_OFFSET2 = 600;  //--------------------------------------------HOW MUCH MOTOR 2 SHOULD BE BELOW LIMIT LEVEL WHEN AT TRUE LEVEL.
const int MOT_OFFSET3 = 705;  //--------------------------------------------HOW MUCH MOTOR 3 SHOULD BE BELOW LIMIT LEVEL WHEN AT TRUE LEVEL.
const int MOT_OFFSET4 = 805;  //--------------------------------------------HOW MUCH MOTOR 4 SHOULD BE BELOW LIMIT LEVEL WHEN AT TRUE LEVEL.
const bool MOT_DIR_INV1 = 0; const bool MOT_DIR_INV2 = 0;  //---------------IF MOTOR TURNS THE WRONG WAY, FLIP THIS BIT
const bool MOT_DIR_INV3 = 1; const bool MOT_DIR_INV4 = 0;  //---------------IF MOTOR TURNS THE WRONG WAY, FLIP THIS BIT
const int MIN_TEMP = 19; const int MAX_TEMP = 40; const int MinFlow = 5; //-MAX COLD, MAX WARM, AND MINIMUM FLOW SETTINGS//NOT SET YET
const int MessageHoldMs = 3000; //------------------------------------------TIME TO KEEP TEMPORARY MESSAGE ON SCREEN (PLUS ONE CYCLE)
const int LimitDeBounceMS = 100;  //----------------------------------------USED FOR LIMIT SWITCH DEBOUNCING, DOES THIS DELAY (IN MS) 2 TIMES TO CONFIRM STATE
const int MenuDeBounceMS = 3000; //------------------------------------------TIME TO IGNORE KEYPAD AFTER A BUTTON IS PRESSED
const int LongPressMS = 5000; //--------------------------------------------TIME BUTTON MUST BE HELD TO GET A 'LONG PRESS'
const int MANUAL_MOTOR_MULTIPLIER = 5;  //----------------------------------NUMBER OF STEPS TO TAKE FOR EVERY MANUAL MOTOR MOVE REQUEST
const float LPMMultiplier = 0.1; //-----------------------------------------MULTIPLIES SMALL VALUE TO GIVE MORE CONTROL
const long EEPROM_WRITE_DELAY = 120000;  //---------------------------------NUMBER OF MS BETWEEN EEPROM UPDATE WRITES, HIGHER REDUCES MEMORY WEAR
const int STEP_DELAY = 6000;  //--------------------------------------------NUMBER OF MICROSECONDS TO DELAY BETWEEN STEPS
const int STEP_HIGH_TIME = 300;  //-----------------------------------------HOW MANY MICROSECONDS TO HOLD MOTOR STEP HIGH
const int STEPPER_EN_LIMIT = 500;  //---------------------------------------HOW MANY MS AFTER MOTOR IN USE TO KEEP IT ENABLED
const int FlowMeterTimer = 800; //------------------------------------------TIME TO SPEND READING FLOW METER IN MILLISECONDS
const long SerialBaud = 115200; //------------------------------------------SERIAL DIAGNOSTICS BAUD RATE
//USER SETTINGS

//GENERAL SETTINGS
const int LeftArrow = 127; //----------------------------USED FOR PUTTING ARROWS NEXT TO MOTORS
const int RightArrow = 126; //---------------------------USED FOR PUTTING ARROWS NEXT TO MOTORS
const int M1ADDR = 3; const int M2ADDR = 7; //-----------EEPROM ADDRESSES FOR STORED LAST LOCATIONS
const int M3ADDR = 11; const int M4ADDR = 15; //----------EEPROM ADDRESSES FOR STORED LAST LOCATIONS
#define RedBL 0x1 #define YelBL 0x3 #define GrnBL 0x2 //-MAKES SETTING BACKLIGHT COLORS EASIER
#define CynBL 0x6 #define BluBL 0x4 #define PrpBL 0x5 //-MAKES SETTING BACKLIGHT COLORS EASIER
#define WhtBL 0x7 //-------------------------------------MAKES SETTING BACKLIGHT COLORS EASIER
//GENERAL SETTINGS

//VARIABLES
byte ErrDetect = 0; byte OldErrDetect = 0;//-----------------------------------------------1=ALMOST TOO COLD, 10=TOO COLD, 11=OVERHEAT, 12=DEW POINT TOO HIGH, 13 = FLOW TOO LOW
double TempVal1 = 0; double TempVal2 = 0; int TempVal3 = 0; int TempVal33 = 0;//-----------TEMPORARY VARIABLES
int TempVal4 = 0;unsigned long TempVal5 = 0; long TempVal6 = 0; //-------------------------TEMPORARY VARIABLES
bool TempWaiting = 1; bool NewBedVal = 1; //-----------------------------------------------THESE ALERT FUNCTIONS THAT A CHANGE NEEDS TO BE DISPLAYED
int ChillTemp = 92; int OldChillTemp = 99; //----------------------------------------------TEMPERATURE FOR CHILLER RETURN LINE & OLD READING
int LaserTemp = 92; int OldLaserTemp = 99; //----------------------------------------------TEMPERATURE FOR LASER RETURN LINE & OLD READING
int CTankTemp = 92; int OldCTankTemp = 99; //----------------------------------------------TEMPERATURE FOR COLD WATER TANK & OLD READING
int WTankTemp = 99; int OldWTankTemp = 99; //----------------------------------------------TEMPERATURE FOR WARM WATER TANK & OLD READING
int AmbTemp = 99; int OldAmbTemp = 99; //--------------------------------------------------AMBIENT AIR TEMPERATURE & OLD READING
int DewPoint = 99; int OldDewPoint = 99; //------------------------------------------------CALCULATED DEW POINT BASED ON DHT & OLD READING
int FlowLPM = 0; int OldFlowLPM = 0; //----------------------------------------------------FLOW METER CALCULATED LPM & OLD READING
long M0T_NOW1 = 0; float MOT_MM_NOW1 = 0; float MOT_MM_OLD1 = 0; //------------------------MOTOR LOCATIONS
long M0T_NOW2 = 0; float MOT_MM_NOW2 = 0; float MOT_MM_OLD2 = 0; //------------------------MOTOR LOCATIONS
long M0T_NOW3 = 0; float MOT_MM_NOW3 = 0; float MOT_MM_OLD3 = 0; //------------------------MOTOR LOCATIONS
long M0T_NOW4 = 0; float MOT_MM_NOW4 = 0; float MOT_MM_OLD4 = 0; //------------------------MOTOR LOCATIONS
unsigned long MOTOR_EN_TIMER = 0; //-------------------------------------------------------USED TO TURN OFF UNUSED STEPPERS
unsigned long EEPROMTIMER = millis(); //---------------------------------------------------USED TO PREVENT EXCESSIVE EEPROM WRITES
long WAITING_STEPS = 0; //-----------------------------------------------------------------HOW MANY STEPS FROM RUIDA ARE YET TO COMPLETE (POSITIVE = MOVE IN 0 DIRECTION)
bool INPUT_DIR = 0; //---------------------------------------------------------------------CURRENT DIRECTION REQUESTED BY RUIDIA
byte INITIALIZE_CONFIRM = 0; //------------------------------------------------------------USED TO CONFIRM BEFORE STARTING INITIALIZATION
bool HOMING_DONE = 0; //-------------------------------------------------------------------USED BY INITIALIZE() LEVELING LOOP
float DHTAirTEMP = 99; float DHTRelHumid = 99; //------------------------------------------USED FOR READING DHT SENSOR
unsigned long FlowMSnow = millis(); bool FlowSignal = 0; //--------------------------------NEEDED FOR FLOW METER COUNTER
bool FlowLatch1 = 0; bool FlowLatch2 = 0; unsigned long FlowCnt = 0; //--------------------NEEDED FOR FLOW METER COUNTER
unsigned long FlowMStotal = 0; unsigned long FlowMSstart = 0; //---------------------------NEEDED FOR FLOW METER COUNTER
bool LaserOn = 1; bool ChillOn = 1; //-----------------------------------------------------STATES USED BY LOGIC, 1=ON
//float BedTyping = 0; //--------------------------------------------------------------------VALUE ENTERED BY KEYPAD
byte CurrentManMot = 5; byte OldManMot = 0; //---------------------------------------------USED BY BED ADJUST SCREEN
byte ChillManMode = 0; byte LaserManMode = 0; //-------------------------------------------0: AUTOMATIC, 1:MANUAL OFF, 2: MANUAL ON
bool LIMIT1_NOW = 0; bool LIMIT2_NOW = 0; bool LIMIT3_NOW = 0; bool LIMIT4_NOW = 0;  //----USED TO STORE CURRENT LIMIT SWITCH STATES
bool ROW1_STATUS; bool ROW2_STATUS; bool ROW3_STATUS; bool ROW4_STATUS; //-----------------USED TO READ NUMBER PAD PINS
bool COL1_STATUS; bool COL2_STATUS; bool COL3_STATUS; //-----------------------------------USED TO READ NUMBER PAD PINS
bool BTN1_STATUS = 0; bool BTN2_STATUS = 0; bool BTN3_STATUS = 0; bool BTN4_STATUS = 0; //-STORES BUTTON STATES
bool BTN5_STATUS = 0; bool BTN6_STATUS = 0; bool BTN7_STATUS = 0; bool BTN8_STATUS = 0; //-STORES BUTTON STATES
bool BTN9_STATUS = 0; bool BTN0_STATUS = 0; bool BTNX_STATUS = 0; bool BTNE_STATUS = 0; //-STORES BUTTON STATES
bool BTNINIT_STAT = 0; //-STORES BUTTON STATES
//VARIABLES

//ATTACH LIBRARIES
AdaRGBMod lcd = AdaRGBMod();  //--------USING ADAFRUIT RGB SHIELD LIBRARY, BUT HACKED UP
OneWire oneWire(PinDallasBus); //-------DALLAS 'ONE WIRE'
DallasTemperature sensors(&oneWire); //-DALLAS 'ONE WIRE'
SimpleDHT22 dht22(PinDHT22); //---------DHT22 SENSOR
Adafruit_MCP23017 _i2c; //--------------FOR READING BUTTONS
//ATTACH LIBRARIES

void setup() {  //
  Serial.begin(SerialBaud);
  lcd.begin(20, 2); //-----------------------------------------------------------START LCD, SET AS 20 COLUMNS AND 2 ROWS
  sensors.begin(); //--------------START DALLAS TEMPERATURE SENSORS
  sensors.setResolution(0,9); //--------------SET DESIRED PRECISION
  sensors.setResolution(1,9); //--------------SET DESIRED PRECISION
  sensors.setResolution(2,9); //--------------SET DESIRED PRECISION
  sensors.setResolution(3,9); //--------------SET DESIRED PRECISION
  sensors.setResolution(4,9); //--------------SET DESIRED PRECISION
  pinMode (PinStep1,OUTPUT); pinMode (PinDir1,OUTPUT); //------------------------CONFIGURE MOTOR 1 PINS
  pinMode (PinStep2,OUTPUT); pinMode (PinDir2,OUTPUT); //------------------------CONFIGURE MOTOR 2 PINS
  pinMode (PinStep3,OUTPUT); pinMode (PinDir3,OUTPUT); //------------------------CONFIGURE MOTOR 3 PINS
  pinMode (PinStep4,OUTPUT); pinMode (PinDir4,OUTPUT); //------------------------CONFIGURE MOTOR 4 PINS
  pinMode(PinEnable,OUTPUT); digitalWrite(PinEnable,HIGH); //--------------------ENABLE PINS OF ALL 4 MOTORS, START DISABLED
  pinMode(PinChill, OUTPUT); pinMode(PinLaser, OUTPUT); pinMode(PinMisc, OUTPUT); //-----------------------SET PIN STATUS
  digitalWrite(PinChill, HIGH); digitalWrite(PinMisc,HIGH); //-----------------------SET PIN STATUS
  pinMode(PinMisc, OUTPUT); //---------------------------------------------------SET PIN STATUS
  digitalWrite(PinFlow,HIGH); pinMode(PinFlow,INPUT); //-------------------------FOR FLOW METER
  pinMode (PinLim1,INPUT_PULLUP); pinMode (PinLim2,INPUT_PULLUP);  //------------CONFIGURE LIMIT PINS 1 & 2
  pinMode (PinLim3,INPUT_PULLUP); pinMode (PinLim4,INPUT_PULLUP);  //------------CONFIGURE LIMIT PINS 3 & 4
  pinMode(PinStepInput,INPUT_PULLUP); pinMode(PinDirInput,INPUT_PULLUP); //------CONFIGURE PINS FROM MAIN CONTROL UNIT
  attachInterrupt(digitalPinToInterrupt(PinDirInput), DIR_NOW, CHANGE);  //----WHEN THIS PIN GOES HIGH OR LOW, RUN THE DIR_NOW FUNCTION IMMEDIATELY
  attachInterrupt(digitalPinToInterrupt(PinStepInput), STEP_NOW, FALLING);  //-WHEN THIS PIN GOES HIGH TO LOW, RUN THE STEP_NOW FUNCTION IMMEDIATEL
  lcd.setBacklight(WhtBL); //----------------------------------------------------TURNS ON MONOCHROME BACKLIGHT OR ALL BACKLIGHTS ON RGB SCREEN
  _i2c.pinMode(MCP_ROW1_PIN, INPUT); _i2c.pullUp(MCP_ROW1_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_ROW2_PIN, INPUT); _i2c.pullUp(MCP_ROW2_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_ROW3_PIN, INPUT); _i2c.pullUp(MCP_ROW3_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_ROW4_PIN, INPUT); _i2c.pullUp(MCP_ROW4_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_COL1_PIN, INPUT); _i2c.pullUp(MCP_COL1_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_COL2_PIN, INPUT); _i2c.pullUp(MCP_COL2_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  _i2c.pinMode(MCP_COL3_PIN, INPUT); _i2c.pullUp(MCP_COL3_PIN, 1); //------------CONFIGURE BUTTON PINS ON MCP23017 THAT'S ALSO HANDLING DISPLAY
  M0T_NOW1 = EEPROM.readLong(M1ADDR); M0T_NOW2 = EEPROM.readLong(M2ADDR); //-------------LOAD LAST KNOWN LOCATIONS FROM EEPROM
  M0T_NOW3 = EEPROM.readLong(M3ADDR); M0T_NOW4 = EEPROM.readLong(M4ADDR); //-------------LOAD LAST KNOWN LOCATIONS FROM EEPROM
  Serial.println("Setup Done"); //-----------------------------------------------GIVE AN UPDATE FOR DIAGNOSTICS
} //-----------------------------------------------------------------------------END OF SETUP




void loop() { 
  DefaultScreen();
}

//void DefaultScreen(){ //-DEFAULT "MAIN" SCREEN
//void MotorScreen(){ //-SPECIAL SCREEN JUST FOR FAST CONTROL OF MOTORS
//void INITIALIZE(){ //-DOES AUTOMATIC BED LEVELING, UPDATES M0T_NOW1, M0T_NOW2, M0T_NOW3, M0T_NOW4
//void MiscOutputsScreen(){ //-MENU; CONTROLS OVERRIDES FOR LASER AND CHILLER SAFETY SYSTEMS

//void FlashWrite(){ //-WRITES MOTOR LOCATIONS TO EEPROM WHEN NEEDED, CALL EVERY LOOP
//void SideControlWorker(){ //-ACTS ON INPUTS FROM RUIDA, CALL EVERY CYCLE
//void SafetyChecker(){ //-CHECKS EVERYTHING FOR PROBLEMS, CAN DISABLE LASER & CHILLER, CALL EACH LOOP
//void EnableEnder(){ //-TURNS OF MOTORS WHEN NOT IN USE

//void GetFlowLPM(){ //-READS THE FLOW SENSOR, UPDATES FlowLPM
//void GetDewPoint(){ //-GETS DEW POINT FROM DHT22 SENSORS, UPDATES DewPoint
//void ReadDallas(){ //-READS THE DALLAS SENSORS, UPDATES ChillTemp, LaserTemp, CTankTemp, WTankTemp, AmbTemp
//void MotArrows(){ //-DRAWS ARROWS AND SPACES TO INDICATE SELECTED MOTOR ON DEFAULT SCREEN
//void DefaultMotArrows(){ //-DRAWS ARROWS AND SPACES TO INDICATE SELECTED MOTOR ON DEFAULT SCREEN
//void WriteScreenMotors(bool MANUALREDRAW){ //-WRITES CURRENT MOTOR POSITIONS TO SCREEN IF NEEDED (0 FOR AUTO, 1 FOR MANUAL REDRAW)
//void WriteMainScreen(){ //-WRITES MAIN SCREEN

//void DIR_NOW(){ INPUT_DIR = digitalRead(PinDirInput); } //---------------------------TIED TO INT: CHANGES DIRECTION TO MATCH INPUT
//void STEP_NOW(){ if (INPUT_DIR == 0){ WAITING_STEPS++; } else {WAITING_STEPS--;}} //-TIED TO INT: INCRAMENTS WAITING_STEPS

//void ReadSensors(){ //-READS DALLAS TEMP SENSORS, DHT22 HUMIDITY SENSOR, AND FLOW METER
//void ReadButtons(){ //-READS ALL THE BUTTONS, MODIFIES BTN0_STATUS,BTN1_STATUS, ETC (INC BTNX_STATUS & BTNE_STATUS)
//void ReadLimits(){ //-READS LIMIT SWITCHES (WITH DEBOUNCING)
//void TurnMotor(bool DIRR, int STEPP, byte UNITT){ //DIRR: 0=DOWN (Z+),1=UP (Z-)
                                                    //STEPP: NUMBER OF STEPS TO TAKE
                                                    //UNITT: MOTOR NUMBER (1, 2, 3, 4...5 is ALL)

void DefaultScreen(){ //-DEFAULT "MAIN" SCREEN
  delay(MenuDeBounceMS); //-----------------------------------------------------------------------TO PREVENT ACCIDENTAL DOUBLE CLICKING
  lcd.setCursor(9, 0); lcd.print("  "); lcd.setCursor(9, 1); lcd.print("  "); //------------------DRAW SOME SPACES
  WriteScreenMotors(1); //------------------------------------------------------------------------WRITES CURRENT MOTOR POSITIONS
  WriteMainScreen(); //--------------------------------------------------------------------WRITES TEMPERATURES & FLOW TO SCREEN
  TempVal3 = 255; //------------------------------------------------------------------------------USED TO SUSTAIN THE WHILE
  while(TempVal3 == 255){ //----------------------------------------------------------------------CHANGE NUMBER TO EXIT LOOP
    if (BTNINIT_STAT == 1){ INITIALIZE(); TempVal3 = 0; } //---------------------------------------BUTTON 1+3 = INITIALIZE
    if (BTNX_STATUS == 1){ MiscOutputsScreen(); TempVal3 = 0; } //--------------------------------BUTTON X = MISC OUTPUTS SCREEN
    if (BTNE_STATUS == 1){ MotorScreen(); TempVal3 = 0; } //------------------------------------ENTER GOES TO BED TYPING SCREEN
    WriteMainScreen(); //------------------------------------------------------------------WRITES TEMPERATURES & FLOW TO SCREEN
    //SafetyChecker();
    SideControlWorker();
    ReadButtons();
    EnableEnder();
    ReadSensors();
    FlashWrite();
} } //--------------------------------------------------------------------------------------------END OF WHILE, END OF DefaultScreen FUNCTION



















void SafetyChecker(){ //-CHECKS EVERYTHING FOR PROBLEMS, CAN DISABLE LASER & CHILLER, CALL EACH LOOP
  ErrDetect = 0; //--------------------------------------------------------------------------------------------SET TO NO ERROR BY DEFAULT
  if ((ChillTemp < MIN_TEMP) || (LaserTemp < MIN_TEMP)){ ErrDetect = 10; } //----------------------------------ERROR 10: TOO COLD
  if ((CTankTemp < MIN_TEMP) || (WTankTemp < MIN_TEMP)){ ErrDetect = 10; } //----------------------------------ERROR 10: TOO COLD
  if (CTankTemp < DewPoint){ ErrDetect = 10; } //--------------------------------------------------------------ERROR 10: TOO COLD
  if ((ChillTemp > MAX_TEMP) || (LaserTemp > MAX_TEMP)){ErrDetect = 11;} //------------------------------------ERROR 11: OVERHEAT
  if ((CTankTemp > MAX_TEMP) || (WTankTemp > MAX_TEMP)){ErrDetect = 11;} //------------------------------------ERROR 11: OVERHEAT
  if (DewPoint > MAX_TEMP){ErrDetect = 12;} //-----------------------------------------------------------------ERROR 12: DEW POINT TOO HIGH
  if (FlowLPM < MinFlow){ErrDetect = 13;} //-------------------------------------------------------------------ERROR 13: FLOW IS TOO LOW
  if ((ChillTemp == MIN_TEMP) || (LaserTemp == MIN_TEMP)) {ErrDetect = 1;} //----------------------------------ERROR 1: AT MINIMUM TEMP
  if ((CTankTemp == MIN_TEMP) || (WTankTemp == MIN_TEMP)) {ErrDetect = 1;} //----------------------------------ERROR 1: AT MINIMUM TEMP
  if (CTankTemp == DewPoint){ErrDetect = 1;} //----------------------------------------------------------------ERROR 1: AT MINIMUM TEMP
  if (OldErrDetect != ErrDetect){OldErrDetect = ErrDetect; ErrDetect = 0;} //----------------------------------REQUIRES TWO ERRORS IN A ROW TO TAKE ACTION
  if (ErrDetect == 10){ lcd.setCursor(0, 0); lcd.print(" WARNING: TOO COLD! "); LaserOn = 0; ChillOn = 0; } //-PRINT WARNING, CHANGE SETTINGS
  if (ErrDetect == 11){ lcd.setCursor(0, 0); lcd.print(" WARNING: TOO WARM! "); LaserOn = 0; ChillOn = 1; } //-PRINT WARNING, CHANGE SETTINGS
  if (ErrDetect == 12){ lcd.setCursor(0, 0); lcd.print(" WARNING: DEW POINT "); LaserOn = 0; ChillOn = 0; } //-PRINT WARNING, CHANGE SETTINGS
  if (ErrDetect == 13){ lcd.setCursor(0, 0); lcd.print(" WARNING: LOW FLOW! "); LaserOn = 0; ChillOn = 0; } //-PRINT WARNING, CHANGE SETTINGS
  if (ErrDetect == 1){ LaserOn = 1; ChillOn = 0; } //----------------------------------------------------------CHANGE SETTINGS, NO WARNING NEEDED
  if (ChillManMode == 1){ ChillOn = 0; } if (ChillManMode == 2){ ChillOn = 1; } //-----------------------------OVERRIDE SETTINGS IF REQUIRED
  if (LaserManMode == 1){ LaserOn = 0; } if (LaserManMode == 2){ LaserOn = 1; } //-----------------------------OVERRIDE SETTINGS IF REQUIRED
  if (ErrDetect > 1){ //----------------------------------------------------IF AN ERROR MESSAGE WAS DISPLAYED
    lcd.setCursor(0, 1); lcd.print("LASER:"); //----------------------------PREP DISPLAY
    if (LaserOn == 1){lcd.print("ON   "); digitalWrite(PinLaser,HIGH); } //-WRITE STATUS TO SCREEN AND PIN
    if (LaserOn == 0){lcd.print("OFF  ") ; digitalWrite(PinLaser,LOW); } //-WRITE STATUS TO SCREEN AND PIN
    lcd.print("CHILL:"); //-------------------------------------------------PREP DISPLAY
    if (ChillOn == 1){lcd.print("ON "); digitalWrite(PinChill,HIGH); } //-WRITE STATUS TO SCREEN AND PIN
    if (ChillOn == 0){lcd.print("OFF"); digitalWrite(PinChill,LOW); } //--WRITE STATUS TO SCREEN AND PIN
    delay(MessageHoldMs); }  //---------------------------------------------PAUSE FOR MESSAGE IF THERE IS ONE, END OF IF OVER 1
    lcd.setCursor(9, 0); lcd.print("  "); lcd.setCursor(9, 1); lcd.print("  "); //------------------DRAW SOME SPACES
    WriteScreenMotors(1); //------------------------------------------------------------------------WRITES CURRENT MOTOR POSITIONS
    WriteMainScreen(); //--------------------------------------------------------------------WRITES TEMPERATURES & FLOW TO SCREEN
} //------------------------------------------------------------------------END OF SAFETY CHECKER

void MiscOutputsScreen(){ //-MENU; CONTROLS OVERRIDES FOR LASER AND CHILLER SAFETY SYSTEMS
  lcd.setCursor(0, 0); lcd.print("CHILL: 1=OFF, 2=AUTO"); //--------PRINT DISPLAY
  lcd.setCursor(0, 1); lcd.print("LASER: 4=OFF, 5=AUTO"); //--------PRINT DISPLAY
  TempVal3 = 255; //------------------------------------------------USED TO SUSTAIN WHILE
  while(TempVal3 == 255){ //----------------------------------------CHANGE TempVal3 TO EXIT
    ReadButtons(); //-----------------------------------------------GET FRESH BUTTON VALUES
    if (BTN1_STATUS == 1){ ChillManMode = 1; TempVal3 = 2; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTN2_STATUS == 1){ ChillManMode = 0; TempVal3 = 1; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTN3_STATUS == 1){ ChillManMode = 2; TempVal3 = 2; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTN4_STATUS == 1){ LaserManMode = 1; TempVal3 = 3; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTN5_STATUS == 1){ LaserManMode = 0; TempVal3 = 1; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTN6_STATUS == 1){ LaserManMode = 2; TempVal3 = 3; } //-----IF BUTTON PRESSED, SET MODE AND VARIABLE FOR AFTER WHILE
    if (BTNE_STATUS == 1){ MotorScreen(); }  //--------------------IF BUTTON PRESSED, EXIT
    if (BTN0_STATUS == 1){ DefaultScreen(); } } //------------------IF BUTTON PRESSED, EXIT, END OF WHILE
  if (TempVal3 == 2){ //--------------------------------------------IF CHILLER OVERRIDE WAS SELECTED
      lcd.setCursor(0, 0); lcd.print("!CHILLER OVERIDE ON!"); //----PRINT DISPLAY
      lcd.setCursor(0, 1); lcd.print("!!ENTER TO CONFIRM!!"); //----PRINT DISPLAY
      delay(MenuDeBounceMS); //-------------------------------------PREVENT ACCIDENTAL CLICKS
      TempVal3 = 255; //--------------------------------------------USED TO SUSTAIN WHILE
      while(TempVal3 == 255){ //------------------------------------CHANGE TempVal3 TO EXIT
        ReadButtons();
        EnableEnder();
        SideControlWorker();
        if (BTNX_STATUS == 1){ ChillManMode = 0; TempVal3 = 1; } //-CANCEL IF BACK BUTTON PRESSED
        if (BTNE_STATUS == 1){ TempVal3 = 1; } //-------------------CHANGE VALUE IF ENTER PRESSED
  }} //-------------------------------------------------------------END OF WHILE, END OF IF 2
  if (TempVal3 == 3){ //--------------------------------------------IF LASER OVERRIDE WAS SELECTED
      lcd.setCursor(0, 0); lcd.print("!!LASER OVERIDE ON!!"); //----PRINT DISPLAY
      lcd.setCursor(0, 1);  lcd.print("!!ENTER TO CONFIRM!!"); //---PRINT DISPLAY
      delay(MenuDeBounceMS); //-------------------------------------PREVENT ACCIDENTAL CLICKS
      TempVal3 = 255; //--------------------------------------------USED TO SUSTAIN WHILE
      while(TempVal3 == 255){ //------------------------------------CHANGE TempVal3 TO EXIT
        ReadButtons();
        EnableEnder();
        SideControlWorker();
        if (BTNX_STATUS == 1){ LaserManMode = 0; TempVal3 = 1; }//--CANCEL IF BACK BUTTON PRESSED
        if (BTNE_STATUS == 1){ TempVal3 = 1; } //-------------------CHANGE VALUE IF ENTER PRESSED
      } }//---------------------------------------------------------END OF WHILE, END OF IF 3
} //----------------------------------------------------------------END OF MiscOutputsScreen


void MotorScreen(){ //-SPECIAL SCREEN JUST FOR FAST CONTROL OF MOTORS
  MotArrows(); //---------------------------------------------------------------------------------DRAW MOTOR SELECTION INDICATORS ON SCREEN
  WriteScreenMotors(1); //------------------------------------------------------------------------WRITES CURRENT MOTOR POSITIONS
  TempVal33 = 255; //------------------------------------------------------------------------------USED TO SUSTAIN THE WHILE
  while(TempVal33 == 255){ //----------------------------------------------------------------------CHANGE NUMBER TO EXIT LOOP
    MotArrows(); //------------------------------------------------------------------------DRAWS ARROWS AND SPACES TO INDICATE SELECTED MOTOR
    if (BTN1_STATUS == 1){ CurrentManMot = 1; } //------------------------------------------------BUTTON 3 SELECT MOTOR 2
    if (BTN2_STATUS == 1){ TurnMotor(1,MANUAL_MOTOR_MULTIPLIER,CurrentManMot); }//----------------MOVE MOTOR(S)
    if (BTN3_STATUS == 1){ CurrentManMot = 2; } //------------------------------------------------BUTTON 3 SELECT MOTOR 2
    if (BTN4_STATUS == 1){ if (CurrentManMot == 1){CurrentManMot = 5;} else{CurrentManMot--;}} //-SCROLL MOTORS
    if (BTN5_STATUS == 1){ CurrentManMot = 5; } //------------------------------------------------BUTTON 5 SELECT ALL MOTORS
    if (BTN6_STATUS == 1){ if (CurrentManMot == 5){CurrentManMot = 1;} else{CurrentManMot++;}} //-SCROLL MOTORS
    if (BTN7_STATUS == 1){ CurrentManMot = 3; } //------------------------------------------------BUTTON 1 SELECT MOTOR 1
    if (BTN8_STATUS == 1){ TurnMotor(0,MANUAL_MOTOR_MULTIPLIER,CurrentManMot); }//----------------MOVE MOTOR(S)
    if (BTN9_STATUS == 1){ CurrentManMot = 4; } //------------------------------------------------BUTTON 3 SELECT MOTOR 2
    if (BTN0_STATUS == 1){ DefaultScreen(); TempVal33 = 0; } //---------------------------------------BUTTON 0 = INITIALIZE
    if (BTNX_STATUS == 1){ MiscOutputsScreen(); TempVal33 = 0; } //------------------------------------BUTTON X = MISC OUTPUTS SCREEN
    if (BTNINIT_STAT == 1){ INITIALIZE(); TempVal33 = 0; } //---------------------------------------BUTTON 1+3 = INITIALIZE
    WriteScreenMotors(0); //----------------------------------------------------------------------WRITES CURRENT POSITION OF MOTORS TO SCREEN
    ReadButtons(); //-----------------------------------------------------------------------------UPDATE BUTTONS
    SideControlWorker(); //-----------------------------------------------------------------------DO ANY WAITING MOVES
    FlashWrite(); //------------------------------------------------------------------------------WRITE LOCATION TO EEPROM AS NEEDED
    EnableEnder(); //-----------------------------------------------------------------------------TURN OFF MOTORS IF THEY ARE UNUSED
} } //--------------------------------------------------------------------------------------------END OF WHILE, END OF DefaultScreen FUNCTION





void ReadSensors(){ //-READS DALLAS TEMP SENSORS, DHT22 HUMIDITY SENSOR, AND FLOW METER
                    //-UPDATES: "TempWaiting" "DewPoint" "ChillTemp" "LaserTemp" "CTankTemp" "WTankTemp" "AmbTemp" "FlowLPM"
    GetDewPoint(); //--------------------------------------------GET THE DEW POINT
    ReadDallas(); //---------------------------------------------READ ALL DALLAS SENSORS
    GetFlowLPM(); //-GET FLOW RATE FROM SENSOR
    if (ChillTemp < 1){ChillTemp = 97;}  if (LaserTemp < 1){LaserTemp = 97;} //---ERROR CHECKING
    if (CTankTemp < 1){CTankTemp = 97;}  if (WTankTemp < 1){WTankTemp = 97;} //---ERROR CHECKING
    if (AmbTemp < 1){AmbTemp = 97;} //--------------------------------------------ERROR CHECKING
    if (ChillTemp > 99){ChillTemp = 99;}  if (LaserTemp > 99){LaserTemp = 99;} //-ROLLOVER PREVENTION
    if (CTankTemp > 99){CTankTemp = 99;}  if (WTankTemp > 99){WTankTemp = 99;} //-ROLLOVER PREVENTION
    if (AmbTemp > 99){AmbTemp = 99;} //-------------------------------------------ROLLOVER PREVENTION
    if (FlowLPM < 1){FlowLPM = 0;} //---------------------------------------------PREVENT NEGATIVE VALUES
    if (FlowLPM > 99){FlowLPM = 99;} //-------------------------------------------ROLLOVER PROTECTION 
} //------------------------------------------------------------------------------END OF ReadSensors

void GetFlowLPM(){ //-READS THE FLOW SENSOR, UPDATES FlowLPM
  FlowCnt = 0; //-------------------------------------------ZERO COUNTER
    FlowMSstart = millis(); //------------------------------SET START TIME TO CURRENT TIME
    FlowMSnow = millis(); //--------------------------------UPDATE TIME
    while ((FlowMSnow - FlowMSstart) <= FlowMeterTimer){ //-BEGINNING OF WHILE
      FlowSignal = digitalRead(PinFlow); //-----------------MAGNET PASS SENSOR = HIGH
      if(FlowSignal==1){ FlowLatch1=1; } //-----------------TRUE WHEN SENSOR IS HIGH
      if(FlowSignal==0){ FlowLatch2=1; } //-----------------TRUE WHEN SENSOR IS LOW
      if(FlowLatch1==1 and FlowLatch2==1){  //--------------IF BOTH ARE TRUE (SPIN DETECTED)
        FlowCnt++; FlowLatch1=0; FlowLatch2=0;//------------INCREMENT FLOW METER COUNT, RESET LATCHES
      } //--------------------------------------------------END OF IF
      FlowMSnow = millis(); //------------------------------UPDATE TIME
    } //----------------------------------------------------END OF WHILE
    FlowMStotal = (FlowMSnow - FlowMSstart); //-------------TOTAL TIME SPENT READING THE SENSOR.
    TempVal5 = ((FlowCnt * 1000)/ FlowMStotal); //----------REVS PER MS (USE AS HZ INPUT)
    TempVal5 = (TempVal5  * 0.232); //----------------------CONVERT hz TO LPM
    TempVal5 = (TempVal5 * LPMMultiplier) ; //--------------FOR MAKING MORE USE OF DISPLAY
    FlowLPM = (int) TempVal5;  //---------------------------LPM ROUNDED DOWN, END OF IF
}

void GetDewPoint(){ //-GETS DEW POINT FROM DHT22 SENSORS, UPDATES DewPoint
  DHTAirTEMP = 97;  DHTRelHumid = 97; //------------------WILL REMAIN 97 IF ERROR
  dht22.read2(&DHTAirTEMP, &DHTRelHumid, NULL);//---------READS SENSOR
  TempVal1 = log(DHTRelHumid / 100);//--------------------DEW POINT CALCULATION
  TempVal2 = ((17.62 * AmbTemp) / (243.5 + AmbTemp));//---DEW POINT CALCULATION
  TempVal1 = (TempVal1 + TempVal2);//---------------------DEW POINT CALCULATION
  TempVal2 = ((243.5 * TempVal1) / (17.62 - TempVal1));//-DEW POINT CALCULATION
  if ((TempVal2 < 50) && (TempVal2 > 0)){ DewPoint = (int) TempVal2; } //---------------------------CONVERT TO INTIGER
}

void ReadDallas(){ //-READS THE DALLAS SENSORS, UPDATES ChillTemp, LaserTemp, CTankTemp, WTankTemp, AmbTemp
  sensors.requestTemperatures(); //---------------------------------------------READ ALL DALLAS SENSORS
  TempVal2 = sensors.getTempCByIndex(FromChillerSensor); //--------------------STORE TEMPERATURE
  if ((TempVal2 < 50) && (TempVal2 > 0)){ ChillTemp = (int) TempVal2; }
  TempVal2 = sensors.getTempCByIndex(FromLaserSensor); //--------------------STORE TEMPERATURE
  if ((TempVal2 < 50) && (TempVal2 > 0)){ LaserTemp = (int) TempVal2; }
  TempVal2 = sensors.getTempCByIndex(ColdTankSensor); //--------------------STORE TEMPERATURE
  if ((TempVal2 < 50) && (TempVal2 > 0)){ CTankTemp = (int) TempVal2; }
  TempVal2 = sensors.getTempCByIndex(WarmTankSensor); //--------------------STORE TEMPERATURE
  if ((TempVal2 < 50) && (TempVal2 > 0)){ WTankTemp = (int) TempVal2; }
  TempVal2 = sensors.getTempCByIndex(AmbientSensor); //--------------------STORE TEMPERATURE
  if ((TempVal2 < 50) && (TempVal2 > 0)){ AmbTemp = (int) TempVal2; }
}


void MotArrows(){ //-DRAWS ARROWS AND SPACES TO INDICATE SELECTED MOTOR ON DEFAULT SCREEN
  if (CurrentManMot == 1){ //--------------------------IF MOTOR 1 SELECTED
        lcd.setCursor(6, 0); lcd.print("<<<<    "); //-PRINT ARROWS & SPACES
        lcd.setCursor(6, 1); lcd.print("        "); //-PRINT ARROWS & SPACES
  } //-------------------------------------------------END OF IF MOTOR 1
  if (CurrentManMot == 2){ //--------------------------IF MOTOR 2 SELECTED
        lcd.setCursor(6, 0); lcd.print("    >>>>"); //-PRINT ARROWS & SPACES
        lcd.setCursor(6, 1); lcd.print("        "); //-PRINT ARROWS & SPACES
  } //-------------------------------------------------END OF IF MOTOR 2
  if (CurrentManMot == 3){ //--------------------------IF MOTOR 3 SELECTED
        lcd.setCursor(6, 0); lcd.print("        "); //-PRINT ARROWS & SPACES
        lcd.setCursor(6, 1); lcd.print("<<<<    "); //-PRINT ARROWS & SPACES
  } //-------------------------------------------------END OF IF MOTOR 3
  if (CurrentManMot == 4){ //--------------------------IF MOTOR 4 SELECTED
        lcd.setCursor(6, 0); lcd.print("        "); //-PRINT ARROWS & SPACES
        lcd.setCursor(6, 1); lcd.print("    >>>>"); //-PRINT ARROWS & SPACES
  } //-------------------------------------------------END OF IF MOTOR 4
  if (CurrentManMot == 5){ //--------------------------IF ALL MOTORS SELECTED
        lcd.setCursor(6, 0); lcd.print("<<<<>>>>"); //-PRINT ARROWS & SPACES
        lcd.setCursor(6, 1); lcd.print("<<<<>>>>"); //-PRINT ARROWS & SPACES
  } //-------------------------------------------------END OF IF MOTOR 5
} //---------------------------------------------------END OF MotArrows FUNCTION

void DIR_NOW(){ INPUT_DIR = digitalRead(PinDirInput); } //---------------------------TIED TO INT: CHANGES DIRECTION TO MATCH INPUT

void STEP_NOW(){ if (INPUT_DIR == 0){ WAITING_STEPS++; } else {WAITING_STEPS--;}} //-TIED TO INT: INCRAMENTS WAITING_STEPS

void SideControlWorker(){ //-ACTS ON INPUTS FROM RUIDA, CALL EVERY CYCLE
  while(WAITING_STEPS < 0){
    TurnMotor(1,1,5);
    WAITING_STEPS++;
  }
  while(WAITING_STEPS > 0){
    TurnMotor(0,1,5);
    WAITING_STEPS--;
  }
} //--------------------------------------------END OF FUNCTION

void WriteScreenMotors(bool MANUALREDRAW){ //-WRITES CURRENT MOTOR POSITIONS TO SCREEN IF NEEDED (0 FOR AUTO, 1 FOR MANUAL REDRAW)
  MOT_MM_NOW1 = (M0T_NOW1 / STEP_PER_MM); MOT_MM_NOW2 = (M0T_NOW2 / STEP_PER_MM); //----------------------------CALULATE THE VALUES
  MOT_MM_NOW3 = (M0T_NOW3 / STEP_PER_MM); MOT_MM_NOW4 = (M0T_NOW4 / STEP_PER_MM); //----------------------------CALULATE THE VALUES
  if (MANUALREDRAW == 1){ MOT_MM_OLD1 = 0; MOT_MM_OLD2 = 0; MOT_MM_OLD3 = 0; MOT_MM_OLD4 = 0; } //--------------IF REDRAW REQUESTED, SET OLD VALUES TO REDRAW
  if (MOT_MM_OLD1 != MOT_MM_NOW1){ //---------------------------------------------------------------------------IF OLD AND NEW VALUES DON'T MATCH, REDRAW
    lcd.setCursor(0, 0); //-------------------------------------------------------------------------------------SET CURSOR LOCATION
    if (MOT_MM_NOW1 >= 0){ if (MOT_MM_NOW1 < 100){lcd.print("0");} if (MOT_MM_NOW1 < 10){lcd.print("0");} } //--PAD POSITIVE VALUES BELOW 100
    lcd.print(MOT_MM_NOW1); //----------------------------------------------------------------------------------PRINT THE CURRENT LOCATION, END OF 'if'
    MOT_MM_OLD1 = MOT_MM_NOW1; } //-----------------------------------------------------------------------------SET OLD AND NEW VALUES TO BE EQUAL, END OF IF
  if (MOT_MM_OLD2 != MOT_MM_NOW2){ //---------------------------------------------------------------------------IF OLD AND NEW VALUES DON'T MATCH, REDRAW
    lcd.setCursor(14, 0); //------------------------------------------------------------------------------------SET CURSOR LOCATION
    if (MOT_MM_NOW2 >= 0){ if (MOT_MM_NOW2 < 100){lcd.print("0");} if (MOT_MM_NOW2 < 10){lcd.print("0");} } //--PAD POSITIVE VALUES BELOW 100
    lcd.print(MOT_MM_NOW2); //----------------------------------------------------------------------------------PRINT THE CURRENT LOCATION, END OF 'if'
    MOT_MM_OLD2 = MOT_MM_NOW2; } //-----------------------------------------------------------------------------SET OLD AND NEW VALUES TO BE EQUAL, END OF IF
  if (MOT_MM_OLD3 != MOT_MM_NOW3){ //---------------------------------------------------------------------------IF OLD AND NEW VALUES DON'T MATCH, REDRAW
    lcd.setCursor(0, 11); //-------------------------------------------------------------------------------------SET CURSOR LOCATION
    if (MOT_MM_NOW3 >= 0){ if (MOT_MM_NOW3 < 100){lcd.print("0");} if (MOT_MM_NOW3 < 10){lcd.print("0");} } //--PAD POSITIVE VALUES BELOW 100
    lcd.print(MOT_MM_NOW3); //----------------------------------------------------------------------------------PRINT THE CURRENT LOCATION, END OF 'if'
    MOT_MM_OLD3 = MOT_MM_NOW3; } //-----------------------------------------------------------------------------SET OLD AND NEW VALUES TO BE EQUAL, END OF IF
  if (MOT_MM_OLD4 != MOT_MM_NOW4){ //---------------------------------------------------------------------------IF OLD AND NEW VALUES DON'T MATCH, REDRAW
    lcd.setCursor(14, 1); //-------------------------------------------------------------------------------------SET CURSOR LOCATION
    if (MOT_MM_NOW4 >= 0){ if (MOT_MM_NOW4 < 100){lcd.print("0");} if (MOT_MM_NOW4 < 10){lcd.print("0");} } //--PAD POSITIVE VALUES BELOW 100
    lcd.print(MOT_MM_NOW4); //----------------------------------------------------------------------------------PRINT THE CURRENT LOCATION, END OF 'if'
    MOT_MM_OLD4 = MOT_MM_NOW4; } //-----------------------------------------------------------------------------SET OLD AND NEW VALUES TO BE EQUAL, END OF IF
} //------------------------------------------------------------------------------------------------------------END OF FUNCTION











void WriteMainScreen(){ //-WRITES 3 TEMPERATURES & THE FLOW RATE TO THE SCREEN IF NEEDED (0=AUTO, 1=FORCE REDRAW)
  lcd.setCursor(0, 0); //-MOVE CURSOR TO FIRST CHARACHTER OF FIRST LINE
  lcd.print("DWPT="); //-WRITE STATIC TEXT
  if (DewPoint < 10){lcd.print("0");} //-PAD VALUE IF NEEDED
  lcd.print(DewPoint); //-WRITE VALUE
  lcd.print(" IN="); //-WRITE STATIC TEXT
  if (CTankTemp < 10){lcd.print("0");} //-PAD VALUE IF NEEDED
  lcd.print(CTankTemp); //-WRITE VALUE
  lcd.print(" OUT="); //-WRITE STATIC TEXT
  if (LaserTemp < 10){lcd.print("0");} //-PAD VALUE IF NEEDED
  lcd.print(LaserTemp); //-WRITE VALUE
  lcd.setCursor(0, 1); //-MOVE CURSOR TO FIRST CHARACHTER OF SECOND LINE
  lcd.print("FLOLPM="); //-WRITE STATIC TEXT
  if (FlowLPM < 10){lcd.print("0");} //-PAD VALUE IF NEEDED
  lcd.print(FlowLPM); //-WRITE VALUE
  lcd.print(" BED="); //-WRITE STATIC TEXT
  TempVal6 = ((MOT_MM_NOW1 + MOT_MM_NOW2 + MOT_MM_NOW3 + MOT_MM_NOW4) / 4); //-GET AVERAGE HEIGHT OF BED
  if (TempVal6 >= 1000){TempVal6 = 999.99;} //-CAP AT 999.999
  if (TempVal6 < 100){lcd.print("0");} if (TempVal6 < 10){lcd.print("0");} //-PAD VALUE IF NEEDED
  lcd.print(TempVal6); //-WRITE VALUE
} //--------------------------------------------------------------------------------------------END OF FUNCTION






















void DefaultMotArrows(){ //-DRAWS ARROWS AND SPACES TO INDICATE SELECTED MOTOR ON DEFAULT SCREEN
  if (CurrentManMot == 1){ //--------------------IF MOTOR 1 SELECTED
        lcd.setCursor(6, 0); lcd.print("<"); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 0); lcd.print(" "); //-WRITE VALUES TO SCREEN
        lcd.setCursor(6, 1); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 1); lcd.print(" "); //-WRITE VALUES TO SCREEN
  } //-------------------------------------------END OF IF MOTOR 1
  if (CurrentManMot == 2){ //--------------------IF MOTOR 2 SELECTED
        lcd.setCursor(6, 0); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 0); lcd.print(">"); //-WRITE VALUES TO SCREEN
        lcd.setCursor(6, 1); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 1); lcd.print(" "); //-WRITE VALUES TO SCREEN
  } //-------------------------------------------END OF IF MOTOR 2
  if (CurrentManMot == 3){ //--------------------IF MOTOR 3 SELECTED
        lcd.setCursor(6, 0); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 0); lcd.print(" "); //-WRITE VALUES TO SCREEN
        lcd.setCursor(6, 1); lcd.print("<"); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 1); lcd.print(" "); //-WRITE VALUES TO SCREEN
  } //-------------------------------------------END OF IF MOTOR 3
  if (CurrentManMot == 4){ //--------------------IF MOTOR 4 SELECTED
        lcd.setCursor(6, 0); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 0); lcd.print(" "); //-WRITE VALUES TO SCREEN
        lcd.setCursor(6, 1); lcd.print(" "); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 1); lcd.print(">"); //-WRITE VALUES TO SCREEN
  } //-------------------------------------------END OF IF MOTOR 4
  if (CurrentManMot == 5){ //--------------------IF ALL 4 MOTORS SELECTED
        lcd.setCursor(6, 0); lcd.print("<"); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 0); lcd.print(">"); //-WRITE VALUES TO SCREEN
        lcd.setCursor(6, 1); lcd.print("<"); //--WRITE VALUES TO SCREEN
        lcd.setCursor(13, 1); lcd.print(">"); //-WRITE VALUES TO SCREEN
  } //-------------------------------------------END OF IF ALL MOTORS
} //---------------------------------------------END OF DefaultMotArrows FUNCTION



void EnableEnder(){ //-TURNS OF MOTORS WHEN NOT IN USE
  TempVal5 = millis(); //-----------------------------------------------------------------VARIABLE FOR NEXT LINE
//  if ((MOTOR_EN_TIMER + STEPPER_EN_LIMIT) < TempVal6){ 
    digitalWrite(PinEnable,HIGH);
//    } //-TURN OFF MOTORS IF NOT IN USE
} //--------------------------------------------------------------------------------------END OF FUNCTION

void ReadButtons(){ //-READS ALL THE BUTTONS, MODIFIES BTN0_STATUS,BTN1_STATUS, ETC (INC BTNX_STATUS & BTNE_STATUS)
  ROW1_STATUS = (_i2c.digitalRead(MCP_ROW1_PIN)); ROW2_STATUS = (_i2c.digitalRead(MCP_ROW2_PIN)); //-------READ ROWS & COLUMNS
  ROW3_STATUS = (_i2c.digitalRead(MCP_ROW3_PIN)); ROW4_STATUS = (_i2c.digitalRead(MCP_ROW4_PIN)); //-------READ ROWS & COLUMNS
  COL1_STATUS = (_i2c.digitalRead(MCP_COL1_PIN)); COL2_STATUS = (_i2c.digitalRead(MCP_COL2_PIN)); //-------READ ROWS & COLUMNS
  COL3_STATUS = (_i2c.digitalRead(MCP_COL3_PIN)); //-------------------------------------------------------READ ROWS & COLUMNS
  BTN1_STATUS = 0; BTN2_STATUS = 0; BTN3_STATUS = 0; BTN4_STATUS = 0; BTN5_STATUS = 0; BTN6_STATUS = 0; //-RESET BUTTONS
  BTN7_STATUS = 0; BTN8_STATUS = 0; BTN9_STATUS = 0; BTN0_STATUS = 0; BTNX_STATUS = 0; BTNE_STATUS = 0; //-RESET BUTTONS
  BTNINIT_STAT = 0; //-RESET BUTTONS
  if ((ROW1_STATUS == 0) && (COL1_STATUS == 0)){ BTN1_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW1_STATUS == 0) && (COL2_STATUS == 0)){ BTN2_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW1_STATUS == 0) && (COL3_STATUS == 0)){ BTN3_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW2_STATUS == 0) && (COL1_STATUS == 0)){ BTN4_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW2_STATUS == 0) && (COL2_STATUS == 0)){ BTN5_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW2_STATUS == 0) && (COL3_STATUS == 0)){ BTN6_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW3_STATUS == 0) && (COL1_STATUS == 0)){ BTN7_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW3_STATUS == 0) && (COL2_STATUS == 0)){ BTN8_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW3_STATUS == 0) && (COL3_STATUS == 0)){ BTN9_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW4_STATUS == 0) && (COL1_STATUS == 0)){ BTNX_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW4_STATUS == 0) && (COL2_STATUS == 0)){ BTN0_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW4_STATUS == 0) && (COL3_STATUS == 0)){ BTNE_STATUS = 1; } //-------------------------------------DEFINE BUTTON STATE BASED ON ROW & HEIGHT
  if ((ROW1_STATUS == 0) && (COL1_STATUS == 0) && (COL3_STATUS == 0)){ BTNINIT_STAT = 1; } //--------------IF BUTTONS 1 & 3 PRESSED, INITIALIZE
} //-------------------------------------------------------------------------------------------------------END OF ReadButtons FUNCTION

void TurnMotor(bool DIRR, int STEPP, byte UNITT){ //DIRR: 0=DOWN (Z+),1=UP (Z-)
                                                  //STEPP: NUMBER OF STEPS TO TAKE
                                                  //UNITT: MOTOR NUMBER (1, 2, 3, 4...5 is ALL).
TempVal3 = 0; //----------------------------------------------------------------RESET VARIABLE
if(STEPP == 0 || UNITT == 0){TempVal3 = 1;} //----------------------------------SKIP IF NO STEPS OR UNITS SPECIFIED
if (UNITT > 5){TempVal3 = 2;} //------------------------------------------------SKIP IF BAD UNIT ID SPECIFIED
if (TempVal3 == 0){ //----------------------------------------------------------MAIN FUNCTION HERE
  digitalWrite(PinEnable,LOW); //-----------------------------------------------ENABLE ALL MOTORS
  if (DIRR == 1){ //------------------------------------------------------------IF DIRECTION 1 SELECTED
    if (UNITT == 1){ //---------------------------------------------------------IF MOTOR 1 SELECTED
      if (MOT_DIR_INV1 == 1){digitalWrite(PinDir1, HIGH);} //-------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV1 == 0){digitalWrite(PinDir1, LOW);} //--------------------SET MOTOR DIRECTION
      while (STEPP > 0){ //-----------------------------------------------------STARTS A LOOP
        STEPP = (STEPP - 1); //-------------------------------------------------COUNT DOWN REMAINING STEPS
        digitalWrite (PinStep1, HIGH); delayMicroseconds(STEP_HIGH_TIME); //----ACTIVATE THE PIN, HOLD HIGH
        digitalWrite (PinStep1, LOW); delayMicroseconds(STEP_DELAY); //---------DEACTIVATE THE PIN, DO A DELAY
        M0T_NOW1 = (M0T_NOW1 - 1); } } //---------------------------------------UPDATE LOCATION VARIABLE, END WHILE, END OF IF 1
    if (UNITT == 2){ if (MOT_DIR_INV2 == 1){digitalWrite(PinDir2, HIGH);} //----SAME AS IF UNIT 1
    if (MOT_DIR_INV2 == 0){digitalWrite(PinDir2, LOW);} //-SAME AS IF UNIT 1 //-SAME AS IF UNIT 1
    while (STEPP > 0){ STEPP = (STEPP - 1); digitalWrite (PinStep2, HIGH); //---SAME AS IF UNIT 1
    delayMicroseconds(STEP_HIGH_TIME); digitalWrite (PinStep2, LOW); //---------SAME AS IF UNIT 1
    delayMicroseconds(STEP_DELAY); M0T_NOW2 = (M0T_NOW2 - 1); } } //------------SAME AS IF UNIT 1
    if (UNITT == 3){ if (MOT_DIR_INV3 == 1){digitalWrite(PinDir3, HIGH);} //----SAME AS IF UNIT 1
    if (MOT_DIR_INV3 == 0){digitalWrite(PinDir3, LOW);} //----------------------SAME AS IF UNIT 1
    while (STEPP > 0){ STEPP = (STEPP - 1); digitalWrite (PinStep3, HIGH); //---SAME AS IF UNIT 1
    delayMicroseconds(STEP_HIGH_TIME); digitalWrite (PinStep3, LOW); //---------SAME AS IF UNIT 1
    delayMicroseconds(STEP_DELAY); M0T_NOW3 = (M0T_NOW3 - 1); } } //------------SAME AS IF UNIT 1
    if (UNITT == 4){ if (MOT_DIR_INV4 == 1){digitalWrite(PinDir4, HIGH);} //----SAME AS IF UNIT 1
    if (MOT_DIR_INV4 == 0){digitalWrite(PinDir4, LOW);} //----------------------SAME AS IF UNIT 1
    while (STEPP > 0){ STEPP = (STEPP - 1); digitalWrite (PinStep4, HIGH); //---SAME AS IF UNIT 1
    delayMicroseconds(STEP_HIGH_TIME); digitalWrite (PinStep4, LOW); //---------SAME AS IF UNIT 1
    delayMicroseconds(STEP_DELAY); M0T_NOW4 = (M0T_NOW4 - 1); } } //------------SAME AS IF UNIT 1
    if (UNITT == 5){  //--------------------------------------------------------IF ALL 4 MOTORS SELECTED
      if (MOT_DIR_INV1 == 1){digitalWrite(PinDir1, HIGH);} //-------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV1 == 0){digitalWrite(PinDir1, LOW);} //--------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV2 == 1){digitalWrite(PinDir2, HIGH);} //-------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV2 == 0){digitalWrite(PinDir2, LOW);} //--------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV3 == 1){digitalWrite(PinDir3, HIGH);} //-------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV3 == 0){digitalWrite(PinDir3, LOW);} //--------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV4 == 1){digitalWrite(PinDir4, HIGH);} //-------------------SET MOTOR DIRECTION
      if (MOT_DIR_INV4 == 0){digitalWrite(PinDir4, LOW);} //--------------------SET MOTOR DIRECTION
      while (STEPP > 0){ //-----------------------------------------------------STARTS A LOOP
        STEPP = (STEPP - 1); //-------------------------------------------------COUNT DOWN REMAINING STEPS
        digitalWrite (PinStep1, HIGH); digitalWrite (PinStep2, HIGH); //--------ACTIVATE THE PINS
        digitalWrite (PinStep3, HIGH); digitalWrite (PinStep4, HIGH); //--------ACTIVATE THE PINS
        delayMicroseconds(STEP_HIGH_TIME); //-----------------------------------HOLD HIGH
        digitalWrite (PinStep1, LOW); digitalWrite (PinStep2, LOW); //----------DEACTIVATE THE PINS
        digitalWrite (PinStep3, LOW); digitalWrite (PinStep4, LOW); //----------DEACTIVATE THE PINS
        delayMicroseconds(STEP_DELAY); //---------------------------------------DO A DELAY
        M0T_NOW1 = (M0T_NOW1 - 1); M0T_NOW2 = (M0T_NOW2 - 1); //----------------UPDATE LOCATION VARIABLES
        M0T_NOW3 = (M0T_NOW3 - 1); M0T_NOW4 = (M0T_NOW4 - 1); } //--------------UPDATE LOCATION VARIABLES, END WHILE
  } } //------------------------------------------------------------------------END OF IF UNIT 5, END OF IF DIR 1
if (DIRR == 0){ if (UNITT == 1){ if (MOT_DIR_INV1 == 1){ //---------------------SAME AS IF DIR 1
digitalWrite(PinDir1, LOW);} if (MOT_DIR_INV1 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir1, HIGH);} while (STEPP > 0){ STEPP = (STEPP - 1); //--------SAME AS IF DIR 1
digitalWrite (PinStep1, HIGH); delayMicroseconds(STEP_HIGH_TIME); //------------SAME AS IF DIR 1
digitalWrite (PinStep1, LOW); delayMicroseconds(STEP_DELAY); //-----------------SAME AS IF DIR 1
M0T_NOW1 = (M0T_NOW1 + 1); } } if (UNITT == 2){ if (MOT_DIR_INV2 == 1){ //------SAME AS IF DIR 1
digitalWrite(PinDir2, LOW);} if (MOT_DIR_INV2 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir2, HIGH);} while (STEPP > 0){ STEPP = (STEPP - 1); //--------SAME AS IF DIR 1
digitalWrite (PinStep2, HIGH); delayMicroseconds(STEP_HIGH_TIME); //------------SAME AS IF DIR 1
digitalWrite (PinStep2, LOW); delayMicroseconds(STEP_DELAY); //-----------------SAME AS IF DIR 1
M0T_NOW2 = (M0T_NOW2 + 1); } } if (UNITT == 3){ if (MOT_DIR_INV3 == 1){ //------SAME AS IF DIR 1
digitalWrite(PinDir3, LOW);} if (MOT_DIR_INV3 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir3, HIGH);} while (STEPP > 0){ STEPP = (STEPP - 1); //--------SAME AS IF DIR 1
digitalWrite (PinStep3, HIGH); delayMicroseconds(STEP_HIGH_TIME); //------------SAME AS IF DIR 1
digitalWrite (PinStep3, LOW); delayMicroseconds(STEP_DELAY); //-----------------SAME AS IF DIR 1
M0T_NOW3 = (M0T_NOW3 + 1); } } if (UNITT == 4){ if (MOT_DIR_INV4 == 1){ //------SAME AS IF DIR 1
digitalWrite(PinDir4, LOW);} if (MOT_DIR_INV4 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir4, HIGH);} while (STEPP > 0){ STEPP = (STEPP - 1); //--------SAME AS IF DIR 1
digitalWrite (PinStep4, HIGH); delayMicroseconds(STEP_HIGH_TIME); //------------SAME AS IF DIR 1
digitalWrite (PinStep4, LOW); delayMicroseconds(STEP_DELAY); //-----------------SAME AS IF DIR 1
M0T_NOW4 = (M0T_NOW4 + 1); } } if (UNITT == 5){ if (MOT_DIR_INV1 == 1){ //------SAME AS IF DIR 1
digitalWrite(PinDir1, LOW);} if (MOT_DIR_INV1 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir1, HIGH);} if (MOT_DIR_INV2 == 1){ //------------------------SAME AS IF DIR 1
digitalWrite(PinDir2, LOW);} if (MOT_DIR_INV2 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir2, HIGH);} if (MOT_DIR_INV3 == 1){ //------------------------SAME AS IF DIR 1
digitalWrite(PinDir3, LOW);} if (MOT_DIR_INV3 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir3, HIGH);} if (MOT_DIR_INV4 == 1){ //------------------------SAME AS IF DIR 1
digitalWrite(PinDir4, LOW);} if (MOT_DIR_INV4 == 0){ //-------------------------SAME AS IF DIR 1
digitalWrite(PinDir4, HIGH);} while (STEPP > 0){ STEPP = (STEPP - 1); //--------SAME AS IF DIR 1
digitalWrite (PinStep1, HIGH); digitalWrite (PinStep2, HIGH); //----------------SAME AS IF DIR 1
digitalWrite (PinStep3, HIGH); digitalWrite (PinStep4, HIGH); //----------------SAME AS IF DIR 1
delayMicroseconds(STEP_HIGH_TIME); digitalWrite (PinStep1, LOW); //-------------SAME AS IF DIR 1
digitalWrite (PinStep2, LOW); digitalWrite (PinStep3, LOW); //------------------SAME AS IF DIR 1
digitalWrite (PinStep4, LOW); delayMicroseconds(STEP_DELAY); //-----------------SAME AS IF DIR 1
M0T_NOW1 = (M0T_NOW1 + 1); M0T_NOW2 = (M0T_NOW2 + 1); //------------------------SAME AS IF DIR 1
M0T_NOW3 = (M0T_NOW3 + 1); M0T_NOW4 = (M0T_NOW4 + 1); }}} //--------------------SAME AS IF DIR 1
  MOTOR_EN_TIMER = millis(); //-------------------------------------------------SET A COUNTER TO TURN OFF THE STEPPER
  } //--------------------------------------------------------------------------END OF 'if' TEMPO1 = 00
EEPROMTIMER = millis(); //------------------------------------------------------RESET TIMER TO REDUCE EEPROM WRITE CYCLES
}  //---------------------------------------------------------------------------END OF TurnMotor FUNCTION

void ReadLimits(){ //-READS LIMIT SWITCHES (WITH DEBOUNCING)
  TempVal3 = digitalRead(PinLim1); //-------READ PIN TO A VARIABLE
  if (TempVal3 != LIMIT1_NOW){ //-----------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
    delay(LimitDeBounceMS); //--------------WAIT FOR PIN READING TO STABILIZE
    TempVal3 = digitalRead(PinLim1); //-----READ PIN TO A VARIABLE
    if (TempVal3 != LIMIT1_NOW){ //---------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
      delay(LimitDeBounceMS); //------------WAIT FOR PIN READING TO STABILIZE
      TempVal3 = digitalRead(PinLim1); //---READ PIN TO A VARIABLE
      if (TempVal3 != LIMIT1_NOW){ //-------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
        LIMIT1_NOW = TempVal3; //-----------AFTER 3 IDENTICAL READINGS, UPDATE THE PIN STATE
  }}} //------------------------------------CLOSE 3 LAYERS OF IF STATEMENTS
  TempVal3 = digitalRead(PinLim2); //-------READ PIN TO A VARIABLE
  if (TempVal3 != LIMIT2_NOW){ //-----------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
    delay(LimitDeBounceMS); //--------------WAIT FOR PIN READING TO STABILIZE
    TempVal3 = digitalRead(PinLim2); //-----READ PIN TO A VARIABLE
    if (TempVal3 != LIMIT2_NOW){ //---------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
      delay(LimitDeBounceMS); //------------WAIT FOR PIN READING TO STABILIZE
      TempVal3 = digitalRead(PinLim2); //---READ PIN TO A VARIABLE
      if (TempVal3 != LIMIT2_NOW){ //-------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
        LIMIT2_NOW = TempVal3; //-----------AFTER 3 IDENTICAL READINGS, UPDATE THE PIN STATE
  }}} //------------------------------------CLOSE 3 LAYERS OF IF STATEMENTS
  TempVal3 = digitalRead(PinLim3); //-------READ PIN TO A VARIABLE
  if (TempVal3 != LIMIT3_NOW){ //-----------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
    delay(LimitDeBounceMS); //--------------WAIT FOR PIN READING TO STABILIZE
    TempVal3 = digitalRead(PinLim3); //-----READ PIN TO A VARIABLE
    if (TempVal3 != LIMIT3_NOW){ //---------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
      delay(LimitDeBounceMS); //------------WAIT FOR PIN READING TO STABILIZE
      TempVal3 = digitalRead(PinLim3); //---READ PIN TO A VARIABLE
      if (TempVal3 != LIMIT3_NOW){ //-------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
        LIMIT3_NOW = TempVal3; //-----------AFTER 3 IDENTICAL READINGS, UPDATE THE PIN STATE
  }}} //------------------------------------CLOSE 3 LAYERS OF IF STATEMENTS
  TempVal3 = digitalRead(PinLim4); //-------READ PIN TO A VARIABLE
  if (TempVal3 != LIMIT4_NOW){ //-----------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
    delay(LimitDeBounceMS); //--------------WAIT FOR PIN READING TO STABILIZE
    TempVal3 = digitalRead(PinLim4); //-----READ PIN TO A VARIABLE
    if (TempVal3 != LIMIT4_NOW){ //---------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
      delay(LimitDeBounceMS); //------------WAIT FOR PIN READING TO STABILIZE
      TempVal3 = digitalRead(PinLim4); //---READ PIN TO A VARIABLE
      if (TempVal3 != LIMIT4_NOW){ //-------IF THE EXISTING PIN STATE DOES NOT MATCH WHAT WAS JUST READ, DO THE FOLLOWING
        LIMIT4_NOW = TempVal3; //-----------AFTER 3 IDENTICAL READINGS, UPDATE THE PIN STATE
  }}} //------------------------------------CLOSE 3 LAYERS OF IF STATEMENTS
} //----------------------------------------END OF ReadLimits

void INITIALIZE(){ //-DOES AUTOMATIC BED LEVELING, UPDATES M0T_NOW1, M0T_NOW2, M0T_NOW3, M0T_NOW4
  INITIALIZE_CONFIRM = 0; HOMING_DONE = 0; //--------------------------------------------RESET VARIABLES
  lcd.setCursor(0, 0); lcd.print("CLEAR BED/HOLD ENTER"); //-----------------------------PRINT WARNING MESSAGE TO LCD
  lcd.setCursor(0, 1); lcd.print("   OR PRESS BACK    "); //-----------------------------PRINT WARNING MESSAGE TO LCD
  while(INITIALIZE_CONFIRM == 0){ //-----------------------------------------------------WAIT FOR INPUT BUTTON CONFIRMATION OR CANCEL
    ReadButtons(); //--------------------------------------------------------------------CRITICAL FUNCTIONS BUT ALSO READS BUTTONS
    if ((BTNX_STATUS == 1) || (BTN1_STATUS == 1)){ INITIALIZE_CONFIRM = 3; } //----------ALL BUTTONS EXCEPT 0 & ENTER WILL CANCEL OUT
    if ((BTN2_STATUS == 1) || (BTN3_STATUS == 1)){ INITIALIZE_CONFIRM = 3; } //----------ALL BUTTONS EXCEPT 0 & ENTER WILL CANCEL OUT
    if ((BTN4_STATUS == 1) || (BTN5_STATUS == 1)){ INITIALIZE_CONFIRM = 3; } //----------ALL BUTTONS EXCEPT 0 & ENTER WILL CANCEL OUT
    if ((BTN6_STATUS == 1) || (BTN7_STATUS == 1)){ INITIALIZE_CONFIRM = 3; } //----------ALL BUTTONS EXCEPT 0 & ENTER WILL CANCEL OUT
    if ((BTN8_STATUS == 1) || (BTN9_STATUS == 1)){ INITIALIZE_CONFIRM = 3; } //----------ALL BUTTONS EXCEPT 0 & ENTER WILL CANCEL OUT
    if (BTNE_STATUS == 1){ INITIALIZE_CONFIRM = 1; } //----------------------------------IF ENTER IS PRESSED, INITIALIZE
  } //-----------------------------------------------------------------------------------END OF WHILE
  if (INITIALIZE_CONFIRM == 1){ //-------------------------------------------------------FAILURES TO CONFIRM RESULT IN SOMETHING OTHER THAN 0 OR 1
    TempVal3 = 0; ReadLimits(); //-------------------------------------------------------RESETS VARIABLE VALUE, READS ALL LIMIT SWITCHES
    if ((LIMIT1_NOW == 1) || (LIMIT2_NOW == 1)){ TempVal3 = 1; } //----------------------IF ONE OF THESE PINS IS HIGH, THE LIMIT SW IS PRESSED
    if ((LIMIT3_NOW == 1) || (LIMIT4_NOW == 1)){ TempVal3 = 1; } //----------------------IF ONE OF THESE PINS IS HIGH, THE LIMIT SW IS PRESSED
    if (TempVal3 == 1){TurnMotor(0,1500,5); } //-----------------------------------------IF ANY OF THE PINS WERE HIGH, MOVE THE BED DOWN 1500 STEPS.
  while(HOMING_DONE == 0){ //------------------------------------------------------------THIS DOES INITIAL HOMING BASED ON LIMIT SWITCHES
    ReadLimits(); //---------------------------------------------------------------------READ ALL THE LIMIT SWITCHES
    if (LIMIT1_NOW == 0){TurnMotor(1,1,1);} if (LIMIT2_NOW == 0){TurnMotor(1,1,2);} //---IF LIMIT SWITCH NOT PRESSED, MOVE UP ONE STEP.
    if (LIMIT3_NOW == 0){TurnMotor(1,1,3);} if (LIMIT4_NOW == 0){TurnMotor(1,1,4);} //---IF LIMIT SWITCH NOT PRESSED, MOVE UP ONE STEP.
    ReadLimits(); //---------------------------------------------------------------------READ ALL THE LIMIT SWITCHES
    TempVal3 = (LIMIT1_NOW + LIMIT2_NOW + LIMIT3_NOW + LIMIT4_NOW); //-------------------MAKING A VARIABLE
    if (TempVal3 == 4){HOMING_DONE = 1;} //----------------------------------------------IF ALL 4 SWITCHES ARE PRESSED AT ONCE, HOMING IS DONE
    if (TempVal3 < 4){ //----------------------------------------------------------------IF LESS THAN 4 SWITCHES ARE PRESSED AT ONCE...
      if (LIMIT1_NOW == 1){TurnMotor(0,1,1);} if (LIMIT2_NOW == 1){TurnMotor(0,1,2);} //-IF THIS LIMIT SW IS PRESSED BUT NOT ALL OTHERS, LOWER BY ONE STEP.
      if (LIMIT3_NOW == 1){TurnMotor(0,1,3);} if (LIMIT4_NOW == 1){TurnMotor(0,1,4);} //-IF THIS LIMIT SW IS PRESSED BUT NOT ALL OTHERS, LOWER BY ONE STEP.
    } } //-------------------------------------------------------------------------------END OF IF LESS THAN 4, END OF INITIAL HOMING WHILE
  M0T_NOW1 = (0 - MOT_OFFSET1); M0T_NOW2 = (0 - MOT_OFFSET2); //-------------------------SET HOME OFFSETS
  M0T_NOW3 = (0 - MOT_OFFSET3); M0T_NOW4 = (0 - MOT_OFFSET4); //-------------------------SET HOME OFFSETS
  TempVal3 = (M0T_NOW1 + M0T_NOW2 + M0T_NOW3 + M0T_NOW4); //-----------------------------IF ALL ARE AT ZERO, THIS WILL BE ZERO.
  while(TempVal3 != 0){ //---------------------------------------------------------------STARTS A LOOP
    if (M0T_NOW1 != 0){TurnMotor(0,1,1);} if (M0T_NOW2 != 0){TurnMotor(0,1,2);} //-------TURN MOTOR 1 BY 1 STEP IF NEEDED
    if (M0T_NOW3 != 0){TurnMotor(0,1,3);} if (M0T_NOW4 != 0){TurnMotor(0,1,4);} //-------TURN MOTOR 1 BY 1 STEP IF NEEDED
    TempVal3 = (M0T_NOW1 + M0T_NOW2 + M0T_NOW3 + M0T_NOW4); //---------------------------IF ALL ARE AT ZERO, THIS WILL BE ZERO
     } //--------------------------------------------------------------------------------END OF WHILE
  M0T_NOW1 = (STEP_PER_MM * Home_Value); //----------------------------------------------SET CURRENT POSITION TO REFLECT DISTANCE
  M0T_NOW2 = M0T_NOW1; M0T_NOW3 = M0T_NOW1; M0T_NOW4 = M0T_NOW1; //----------------------FROM BED TO LENS
  lcd.setCursor(0, 0); lcd.print("  AUTO LEVELING IS  "); //-----------------------------WRITE FIRST LINE OF COMPLETION MESSAGE
  lcd.setCursor(0, 1); lcd.print("      COMPLETE      "); //-----------------------------WRITE SECOND LINE OF COMPLETION MESSAGE
  delay(MessageHoldMs); //---------------------------------------------------------------LEAVE MESSAGE ON SCREEN 
  DefaultScreen(); //--------------------------------------------------------------------RETURN TO MAIN SCREEN WHEN DONE
} } //-----------------------------------------------------------------------------------END OF WHAT HAPPENS IF CONFIRMATION IS GIVEN, END OF FUNCTION 

void FlashWrite(){ //-WRITES MOTOR LOCATIONS TO EEPROM WHEN NEEDED, CALL EVERY LOOP
  TempVal5 = millis(); //--------------------------------------------------------------------------------------SET TO CURRENT TIME
  if (TempVal5 > (EEPROMTIMER + EEPROM_WRITE_DELAY)){ //-------------------------------------------------------ONLY DO IF TIMER HAS RUN OUT
    TempVal6 = EEPROM.readLong(M1ADDR);  //------------------------------------------------------------------------READ FROM EEPROM
    if (TempVal6 != M0T_NOW1){ EEPROM.writeLong(M1ADDR,M0T_NOW1); Serial.print("Wrote EEPROM Spot 4: "); Serial.println(EEPROM.readLong(M4ADDR)); }  //-WRITE TO EEPROM IF DIFFERENT
    TempVal6 = EEPROM.readLong(M2ADDR);  //------------------------------------------------------------------------READ FROM EEPROM
    if (TempVal6 != M0T_NOW2){ EEPROM.writeLong(M2ADDR,M0T_NOW2); Serial.print("Wrote EEPROM Spot 4: "); Serial.println(EEPROM.readLong(M4ADDR)); }  //-WRITE TO EEPROM IF DIFFERENT
    TempVal6 = EEPROM.readLong(M3ADDR);  //------------------------------------------------------------------------READ FROM EEPROM
    if (TempVal6 != M0T_NOW3){ EEPROM.writeLong(M3ADDR,M0T_NOW3); Serial.print("Wrote EEPROM Spot 4: "); Serial.println(EEPROM.readLong(M4ADDR)); }  //-WRITE TO EEPROM IF DIFFERENT
    TempVal6 = EEPROM.readLong(M4ADDR);  //------------------------------------------------------------------------READ FROM EEPROM
    if (TempVal6 != M0T_NOW4){ EEPROM.writeLong(M4ADDR,M0T_NOW4); Serial.print("Wrote EEPROM Spot 4: "); Serial.println(EEPROM.readLong(M4ADDR)); }  //-WRITE TO EEPROM IF DIFFERENT
    EEPROMTIMER = millis(); }  //------------------------------------------------------------------------------RESET COUNTER, END OF IF
}  //----------------------------------------------------------------------------------------------------------END OF FUNCTION

//void BedTypingScreen(){ //-MENU; FOR TYPING OVERALL BED HEIGHT USER WANTS
//  lcd.clear(); //------------------------------------------------CLEAR OFF WHATEVER IS THERE FROM LAST SCREEN
//  NewBedVal = 1; //-----------------------------------------------------------------------------------------RESET VARIABLE
//  BedTyping = TempVal3; BedTyping = (BedTyping / 10); //----------------------------------------------------GET THE FIRST DIGIT, DIVIDE BY 10
//  lcd.setCursor(0, 0); lcd.print("OLD HEIGHT: "); //--------------------------------------------------------PREP DISPLAY
//  TempVal3 = (MOT_MM_NOW1 + MOT_MM_NOW2 + MOT_MM_NOW3 + MOT_MM_NOW4); //------------------------------------ADD UP BED CORNERS
//  TempVal1 = (TempVal3 / 4); lcd.print(TempVal1); //--------------------------------------------------------DIVIDE BY 4 TO GET AVERAGE, WRITE TO DISPLAY
//  lcd.setCursor(0, 1); lcd.print(" NEW HEIGHT: "); //-------------------------------------------------------PREP DISPLAY
//  TempVal4 = 255; //----------------------------------------------------------------------------------------USED IN UPCOMING WHILE LOOP
//  while(TempVal4 == 255){ //--------------------------------------------------------------------------------CHANGE THIS VALUE TO EXIT THE LOOP
//    if (NewBedVal == 1){ //---------------------------------------------------------------------------------ONLY IF VARIABLE TRIPS
//      NewBedVal = 0; //-------------------------------------------------------------------------------------RESET VARIABLE
//      lcd.setCursor(13, 1); lcd.print(BedTyping); } //------------------------------------------------------WRITE DISPLAY, END OF IF
//    delay(MenuDeBounceMS); //-------------------------------------------------------------------------------TO PREVENT ACCIDENTAL DOUBLES
//    EssentialLoop(); //-------------------------------------------------------------------------------------ALWAYS DO THE ESSENTIALS
//    lcd.blink(); //-----------------------------------------------------------------------------------------TURN ON BLINKING CURSOR
//    if (BTN1_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.1); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN2_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.2); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN3_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.3); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN4_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.4); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN5_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.5); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN6_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.6); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN7_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.7); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN8_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.8); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN9_STATUS == 1){ BedTyping = (BedTyping * 10); BedTyping = (BedTyping + 0.9); NewBedVal = 1; } //-ADD DIGIT
//    if (BTN0_STATUS == 1){ BedTyping = (BedTyping * 10); NewBedVal = 1; } //--------------------------------ADD DIGIT
//    if (BTNX_STATUS == 1){ DefaultScreen(); TempVal4 = 0; BedTyping = TempVal1;} //-------------------------EXIT IF BACK BUTTON PRESSED
//    if (BTNE_STATUS == 1){ //-------------------------------------------------------------------------------IF ENTER BUTTON PRESSED
//      if (BedTyping == 0){ INITIALIZE(); TempVal4 = 0; BedTyping = TempVal1; } //---------------------------ENTERING "0" BRINGS UP INIT MENU (BED CAN NEVER GET TO 0)
//      if (BedTyping < TempVal1){  //------------------------------------------------------------------------IF BED IS MOVING UP
//        TempVal1 = (TempVal1 - BedTyping); //---------------------------------------------------------------CALCULATE HOW FAR
//        TempVal3 = TempVal1; //-----------------------------------------------------------------------------TO MAKE INTIGER
//        TurnMotor(1,TempVal3,5); //-------------------------------------------------------------------------TURN THE MOTORS
//        TempVal4 = 0; //------------------------------------------------------------------------------------ENDS WHILE LOOP
//        BedTyping = TempVal1;  //---------------------------------------------------------------------------PREVENTS FUTURE IF STATEMENTS
//      } //--------------------------------------------------------------------------------------------------END OF IF MOVING UP
//      if (BedTyping > TempVal1){ //-------------------------------------------------------------------------IF BED IS MOVING DOWN
//        TempVal1 = (BedTyping - TempVal1); //---------------------------------------------------------------CALCULATE HOW FAR
//        TempVal3 = TempVal1; //-----------------------------------------------------------------------------TO MAKE INTIGER
//        TurnMotor(0,TempVal3,5); //-------------------------------------------------------------------------TURN THE MOTORS
//        TempVal4 = 0; //------------------------------------------------------------------------------------ENDS WHILE LOOP
//        BedTyping = TempVal1;  //---------------------------------------------------------------------------PREVENTS FUTURE IF STATEMENTS
//      } //--------------------------------------------------------------------------------------------------END OF IF MOVING DOWN
//    } //----------------------------------------------------------------------------------------------------END OF IF BUTTON E
//    if (BedTyping > MaxZval){ //----------------------------------------------------------------------------IF REQUESTED HEIGHT IS MORE THAN BED CAN MOVE
//      lcd.setCursor(0, 0); lcd.print("ERROR: BEYOND MAX Z!"); //--------------------------------------------WRITE DISPLAY
//      lcd.setCursor(0, 1); lcd.print("!!!CLEARING VALUE!!!"); //--------------------------------------------WRITE DISPLAY
//      delay(MessageHoldMs); //------------------------------------------------------------------------------PAUSE ON SCREEN
//      BedTyping = 0; //-------------------------------------------------------------------------------------RESET VALUE
//      lcd.setCursor(0, 0); lcd.print("OLD HEIGHT: "); //----------------------------------------------------PREP DISPLAY
//      lcd.print(TempVal1); //-------------------------------------------------------------------------------WRITE VALUE TO DISPLAY.
//      lcd.setCursor(0, 1); lcd.print(" NEW HEIGHT: "); //---------------------------------------------------PREP DISPLAY
//  }} //-----------------------------------------------------------------------------------------------------END OF IF & WHILE
//  lcd.noBlink(); //-----------------------------------------------------------------------------------------TURN OFF BLINKING CURSOR
//} //--------------------------------------------------------------------------------------------------------END OF BedTypingScreen

//4 STEPPER MOTORS, 1 = LR (0,500 of bed), 2 = RR (700,500 of bed), 3 = LF (0,0 of bed), 4 = RF (700,0 of bed)

//200 STEP PER TURN MOTORS
//DRIVING PULLEY = 14T
//DRIVEN PULLEY = 15T
//4MM/TURN RODS
//53.57142857142857 STEPS = 1MM

//31.875MM = CENTER OF LENS TO TIP

//  C   C   C
//  O   O   O
//  L   L   L
//  1   2   3   
//-------------
//| 1 | 2 | 3 | ROW1
//-------------
//| 4 | 5 | 6 | ROW2
//-------------
//| 7 | 8 | 9 | ROW3
//-------------
//| X | 0 | Y | ROW4
//-------------



//00000000001111111111
//01234567890123456789
//--------------------
//123.12 99  99 123.12
//123.12 99  99 123.12
//123.12<<<<    123.12
//DWPT=99 IN=99 OUT=99
//FLOLPM=99 BED=000.00
